CASUALTY = {}
CASUALTY.Timeout = nil
CASUALTY.casualties = {}
CASUALTY_CONFIG = {
   ["Delay"] = 1,
   ["SpeechDelay"] = 2,
   ["Enabled"] = true
}

function CASUALTY.OnLoad()
   this:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH")
   SLASH_CASUALTY1 = "/casualty"
   SlashCmdList["CASUALTY"]=CASUALTY.ConsoleCommand
end

function CASUALTY.ConsoleCommand()
   CASUALTY_CONFIG.Enabled = CASUALTY_CONFIG.Enabled == false
   if CASUALTY_CONFIG.Enabled then
      yak_print("Casualty reporting enabled")
   else
      yak_print("Casualty reporting disabled")
      CASUALTY.casualties = {}
   end
end

function CASUALTY.matches_message( arg, template )
   -- returns whether or not the string matches the template
   -- and as a second return, the name of the object matched
   local msg = string.gsub(template, "%%s", "(.-)")
   -- following gyrations are to match the empty message, particularly with
   -- PARTYKILLOTHER
   local emptymsg = string.gsub(template, "%%s", "",1)
   emptymsg = string.gsub(emptymsg, "%%s", "(.-)")
   local beginpos, endpos = string.find(arg,msg)
   if beginpos then
--      yak_print(emptymsg)
      nbegin, nend = string.find(arg, emptymsg)
--      yak_print("arg: "..arg.."; beginpos: "..nbegin.."; name: "..string.sub(arg,1,nbegin-1))
      return true, string.sub(arg, 1, nbegin-1)
   else
      return false
   end
end

function CASUALTY.log_death_if_matched(arg, template)
   local matched, name = CASUALTY.matches_message(arg, template)
--   if matched then yak_print("matched "..name) else yak_print("not matched") end
   if matched then
--      yak_print("adding casualty: ".. name)
      if CASUALTY.Timeout then
	 table.insert( CASUALTY.casualties, name )
      else
	 CASUALTY.Timeout = GetTime() + CASUALTY_CONFIG.Delay
	 CASUALTY.casualties = {name}
      end
   end
end

function CASUALTY.on_death_event()
   if CASUALTY_CONFIG.Enabled then
      -- look at the argument to see if it's something we want to match
      CASUALTY.log_death_if_matched(arg1, PARTYKILLOTHER)
      CASUALTY.log_death_if_matched(arg1, UNITDESTROYEDOTHER)
      CASUALTY.log_death_if_matched(arg1, UNITDIESOTHER)
      --   CASUALTY.log_death_if_matched(arg, UNITDIESSELF)
   end
end

CASUALTY.EventHandlers = {
   ["CHAT_MSG_COMBAT_FRIENDLY_DEATH"] = CASUALTY.on_death_event
}

function CASUALTY.OnEvent(event)
   func = CASUALTY.EventHandlers[event]
   if func then
      func()
   end
end

function CASUALTY.OnUpdate()
   if CASUALTY.Timeout and CASUALTY_CONFIG.Enabled then
      if CASUALTY.Timeout < GetTime() then
	 -- we've timed out since seeing a death; time to report our message
	 if table.getn( CASUALTY.casualties ) == 1 then
	    CASUALTY.ReportCasualty()
	 elseif table.getn( CASUALTY.casualties ) > 1 then
	    CASUALTY.ReportCasualties()
	 else
	    CASUALTY.Timeout = nil
	 end
      end
   end
end

function CASUALTY.ReportCasualty()
   DEFAULT_CHAT_FRAME:AddMessage("Casualty: ".. CASUALTY.casualties[1])
   PlaySoundFile("Interface\\Addons\\Casualty\\Sounds\\casualty.wav")
   CASUALTY.Timeout = GetTime() + CASUALTY_CONFIG.SpeechDelay
   CASUALTY.casualties = {}
end

function CASUALTY.ReportCasualties()
   local msg = "Casualties: "
   for k,v in ipairs(CASUALTY.casualties) do
      msg = msg .. v..", "
   end
   msg = string.sub(msg, 1, -3)
   DEFAULT_CHAT_FRAME:AddMessage(msg)
   result = PlaySoundFile("Interface\\Addons\\Casualty\\Sounds\\casualties.wav")
   if result then
      yak_print("Played OK")
   else
      yak_print("couldn't be found")
   end
   CASUALTY.Timeout = GetTime() + CASUALTY_CONFIG.SpeechDelay
   CASUALTY.casualties = {}
end
